#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "btree_mem.h"

int
cmp(void * a, void * b)
   {
   return strcmp(a, b);
   }


void
print_data(int depth, void * key, void * data)
   {
   for (int i = 0; i < depth; i++)
      printf("\t");
   printf("%d %s\n", *((int*)key), (char *) data);
   }

void
print_tree(struct btree_mem * bt)
   {
   printf("==================================\n");
   btree_mem_walk_inorder(bt, print_data);
   printf("==================================\n");
   }

int
main(int argc, char ** argv)
   {
#define MINDEGREE 3
   struct btree_mem * bt = btree_mem_new(MINDEGREE, cmp);
   if (NULL == bt)
      {
      fprintf(stderr, "Unable to create new btree_mem\n");
      exit(EXIT_FAILURE);
      }

#define MAXKEYS 20
   int keys[MAXKEYS] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
			 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 };
   char * data[MAXKEYS] = { "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine",
			    "ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen" };

   for (int i = 0; i < MAXKEYS; i++)
      {
      print_tree(bt);
      if (NULL == btree_mem_insert(bt, keys+i, data[i]))
	 {
	 fprintf(stderr, "btree_mem_insert failed\n");
	 exit(EXIT_FAILURE);
	 }
      }
   print_tree(bt);

   exit(EXIT_SUCCESS);
   }
